<template>
  <div class="ac-multi-search">
    <b-input-group>
      <b-input
        v-model="input_val"
        @input="on_input"
        @keypress.enter="$emit('enter', build_cursor())"
      />

      <b-input-group-append>
        <b-button
          variant="outline-secondary"
          @click="on_input"
        >
          search
        </b-button>
      </b-input-group-append>
    </b-input-group>

    <div class="results-wrapper mb-2">
      <ac-collection-grouped
        ref="collection"
        sort_key=""
        :ac_cursor="cursor"
        :group_key="group_key"
        :url="this.url"
        :loading_image="loading_image"
        method="GET"
        class="results"
        @success="on_success_load"
      >

        <template #group_header="{ title }">
          <!-- @slot result_title slot for each title in query result -->
          <slot name="result_title" :title="title"></slot>
        </template>

        <template
          #body="{ data }"
          class="item"
        >
          <div
            v-for="(value, key) in data"
            :key="key"
          >
            <!-- @slot result_body slot for each body in query result -->
            <slot name="result_body" :item="value"></slot>
          </div>
        </template>

        <template
          #footer
        >
          <div v-show="is_result_data">
            <div
              class="text-center"
            >
              <b-link v-if="!$slots.more_btn" :href="more_btn_link">More...</b-link>

              <!-- @slot more_btn slot for for more button -->
              <slot name="more_btn"></slot>
            </div>
          </div>
        </template>
      </ac-collection-grouped>
    </div>

    <div class="options">
      <b-form-checkbox-group
        v-if="!$slots.types"
        v-model="selected"
        name="flavour-1"
      >
        <b-form-checkbox
          v-for="item in types"
          :key="item.value"
          :value="item.value"
        >
          {{ item.label }}
        </b-form-checkbox>
      </b-form-checkbox-group>

      <!-- @slot types slot for types checkboxes -->
      <slot name="types" :types="types"></slot>
    </div>
  </div>
</template>

<script>
import acCollectionGrouped from '../ac-collection-grouped.vue'

/**
 * ac multi search component
 * @requires VueBootstrap
 * @requires ac-collection-grouped.vue
 */

let timeout = null

export default {
  name: 'ac-multi-search',

  components: {
    acCollectionGrouped,
  },

  props: {
    /**
     * @param {string} url - url to get data from
     * Required
     */
    url: {
      type: String,
      required: true,
    },

    /**
     * @param {array} types - array of types
     * Required
     */
    types: {
      type: Array,
      required: true,
      default: () => ([]),
    },

    /**
     * @param {string} loading_image - Image to show while loading data
     */
    loading_image: {
      type: String,
      required: true,
    },

    /**
     * @param {string} group_key - Data from every request will be grouped with this key
     * Required
     */
    group_key: {
      type: String,
      required: true,
    },

    /**
     * @param {string} search_param - parameter in request for input value
     * @default 'q'
     */
    search_param: {
      type: String,
      required: false,
      default: 'q',
    },

    /**
     * @param {string} more_btn_link - default more button link href
     */
    more_btn_link: {
      type: String,
      required: false,
      default: '#',
    },
  },

  data() {
    return {
      input_val: '',
      selected: [],
      cursor: {},
      is_result_data: false,
    }
  },

  created() {
    this.set_default_checked()
  },

  methods: {
    /**
     * @function build_cursor - get cursor with current parameters
     * @returns {object} cursor
     */
    build_cursor() {
      const obj = {
        [this.search_param]: this.input_val,
        types: '',
      }

      this.selected.forEach((el) => {
        obj.types += `${el},`
      })

      return obj
    },

    /**
     * @function set_default_checked - for each checked type add value to selected
     */
    set_default_checked() {
      this.types.forEach((el) => {
        if (el.checked) {
          this.selected.push(el.value)
        }
      })
    },

    /**
     * @function get_selected - get current selected types
     * @returns {array} selected
     */
    get_selected() {
      return [...this.selected]
    },

    /**
     * @function set_selected - set current selected types
     * @param {array} new_selected - array with selected values
     * e.g. ['all', 'contacts']
     */
    set_selected(new_selected) {
      this.selected = [...new_selected]
    },

    /**
     * @function send_request - send ajax to url if input is not empty
     */
    send_request() {
      this.cursor = this.build_cursor()

      if (!this.input_val) {
        this.$refs.collection.set_data([])
        this.is_result_data = false
        return
      }

      setTimeout(() => {
        this.$refs.collection.set_ajax()
      }, 50)
    },

    /**
     * @function on_success_load - load data handler
     */
    on_success_load(data) {
      this.is_result_data = Object.keys(data).length > 0
    },

    /**
     * @function on_input - input handler
     */
    on_input() {
      clearTimeout(timeout)

      timeout = setTimeout(() => {
        this.send_request()
      }, 350)
    },
  },
}
</script>

<style scoped>
  .results-wrapper {
    position: relative;
  }

  .results {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    z-index: 1;
    background-color: white;
  }
</style>
